SystemOrganization addCategory: #ConfigurationOfRefactoringBrowser!

Object subclass: #ConfigurationOfRefactoringBrowser
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfRefactoringBrowser'!

!ConfigurationOfRefactoringBrowser class methodsFor: 'private' stamp: 'MarianoMartinezPeck 12/18/2009 16:21'!
bootstrapPackage: aString from: aPath 
	| repository version |
	repository := MCHttpRepository
				location: aPath
				user: ''
				password: ''.
	repository
		versionReaderForFileNamed: aString , '.mcz'
		do: [:reader | 
			version := reader version.
			version load.
			version workingCopy repositoryGroup addRepository: repository]! !

!ConfigurationOfRefactoringBrowser class methodsFor: 'private' stamp: 'DaleHenrichs 12/29/2009 17:57'!
ensureMetacello
	"Bootstrap Gofer (if necessary), bootstrap ConfigurationOfMetacello (using old Gofer API), then load the latest 
	version of Metacello itself."

	Smalltalk at: #MetacelloProject ifAbsent: [
		Smalltalk at: #Gofer ifAbsent: [
			"Current version of Gofer from which to bootstrap - as of 1.0-beta.15"
			self bootstrapPackage: 'Gofer-lr.83' from: 'http://seaside.gemstone.com/ss/metacello' ].
		Smalltalk at: #Gofer ifPresent: [:goferClass | | gofer |
			gofer := goferClass new
				url: 'http://seaside.gemstone.com/ss/metacello';
				yourself.
			[ gofer addPackage: 'ConfigurationOfMetacello' ] on: Warning do: [:ex | ex resume ].
			gofer load ].
		"load latest version of Metacello, load a specific version if desired"
		(Smalltalk at: #ConfigurationOfMetacello) perform: #loadLatestVersion ]! !

!ConfigurationOfRefactoringBrowser class methodsFor: 'metacello tool support' stamp: 'MarianoMartinezPeck 12/18/2009 16:21'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfRefactoringBrowser class methodsFor: 'metacello tool support' stamp: 'MarianoMartinezPeck 12/18/2009 16:21'!
lastMetacelloVersionLoad
	"Answer the last version loaded and the list of packages loaded for that version."

	LastVersionLoad == nil ifTrue: [ LastVersionLoad := nil -> 'default' ].
	^LastVersionLoad! !

!ConfigurationOfRefactoringBrowser class methodsFor: 'metacello tool support' stamp: 'MarianoMartinezPeck 12/18/2009 16:21'!
metacelloVersion: versionString loads: anArrayOrString
	"Stash the last version loaded and the list of packages loaded for that version. The list
	 of packages will be used by the tools when doing 'Load Package Version'"

	LastVersionLoad := versionString -> anArrayOrString! !

!ConfigurationOfRefactoringBrowser class methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 12/18/2009 16:21'!
project

	^self new project! !

!ConfigurationOfRefactoringBrowser methodsFor: 'baselines' stamp: 'dkh 1/12/2010 11:17'!
baseline10: spec 
	<version: '1.0-baseline'>
	
	spec for: #common do: [
		spec blessing: #baseline.
	].
	
	spec for: #pharo do: [
		spec repository: 'http://www.squeaksource.com/rb'.
		spec 
			package: 'AST-Core';
			package: 'AST-Tests' with: [ spec requires: 'AST-Core' ];
			package: 'Refactoring-Core' with: [ spec requires: 'AST-Core' ];
			package: 'Refactoring-Tests' with: [ spec requires: 'Refactoring-Core' ];
			package: 'Refactoring-Spelling' with: [ spec requires: 'Refactoring-Core' ].

		spec
			group: 'default' with: #('Core' );
			group: 'Core' with: #( 'AST-Core' 'Refactoring-Core' 'Refactoring-Spelling' );
			group: 'Tests' with: #( 'AST-Tests' 'Refactoring-Tests' );
			group: 'Core Tests' with: #('Core' 'Tests' );
			
			yourself.
	].
	spec for: #squeak do: [
		spec repository: 'http://source.wiresong.ca/ob/'.
		spec 
			package: 'AST-Core';
			package: 'Refactoring-Core' with: [ spec requires: 'AST-Core' ];
			package: 'Refactoring-Spelling' with: [ spec requires: 'Refactoring-Core' ].

		spec
			group: 'default' with: #('Core' );
			group: 'Core' with: #( 'AST-Core' 'Refactoring-Core' 'Refactoring-Spelling' );
			group: 'Tests' with: #('Core');
			group: 'Core Tests' with: #('Core' 'Tests' );
			
			yourself.
	].
! !

!ConfigurationOfRefactoringBrowser methodsFor: 'baselines' stamp: 'MarianoMartinezPeck 1/20/2010 22:05'!
baseline11: spec 
	<version: '1.1-baseline'>
	
	spec for: #common do: [
		spec blessing: #baseline.
	].
	
	spec for: #pharo do: [
		spec repository: 'http://www.squeaksource.com/rb'.
		spec 
			package: 'AST-Core';
			package: 'AST-Tests' with: [ spec requires: 'AST-Core' ];
			package: 'Refactoring-Core' with: [ spec requires: 'AST-Core' ];
			package: 'Refactoring-Tests' with: [ spec requires: 'Refactoring-Core' ];
			package: 'Refactoring-Spelling' with: [ spec requires: 'Refactoring-Core' ].
			"package: 'Refactoring-Tests-Spelling' with: [ spec 
				requires: 'Refactoring-Spelling';
				repository: 'http://www.squeaksource.com/RBBugFixes'];
			package: 'Refactoring-Spelling-BugFixes' with: [ spec 
				requires: 'Refactoring-Spelling';
				repository: 'http://www.squeaksource.com/RBBugFixes']."

		spec
			group: 'default' with: #('Core' );
			group: 'Core' with: #( 'AST-Core' 'Refactoring-Core' 'Refactoring-Spelling' "'Refactoring-Spelling-BugFixes'" );
			group: 'Tests' with: #( 'AST-Tests' 'Refactoring-Tests' "'Refactoring-Tests-Spelling'" );
			group: 'Core Tests' with: #('Core' 'Tests' );
			
			yourself.
	].
	spec for: #squeak do: [
		spec repository: 'http://source.wiresong.ca/ob/'.
		spec 
			package: 'AST-Core';
			package: 'Refactoring-Core' with: [ spec requires: 'AST-Core' ];
			package: 'Refactoring-Spelling' with: [ spec requires: 'Refactoring-Core' ].

		spec
			group: 'default' with: #('Core' );
			group: 'Core' with: #( 'AST-Core' 'Refactoring-Core' 'Refactoring-Spelling' );
			group: 'Tests' with: #('Core');
			group: 'Core Tests' with: #('Core' 'Tests' );
			
			yourself.
	].
! !

!ConfigurationOfRefactoringBrowser methodsFor: 'baselines' stamp: 'MarianoMartinezPeck 1/24/2010 15:58'!
baseline12: spec 
	<version: '1.2-baseline'>
	
	spec for: #common do: [
		spec blessing: #baseline.
	].
	
	spec for: #pharo do: [
		spec repository: 'http://www.squeaksource.com/rb'.
		spec 
			package: 'AST-Core';
			package: 'AST-Tests-Core' with: [ spec requires: 'AST-Core' ];
			package: 'Refactoring-Core' with: [ spec requires: 'AST-Core' ];
			package: 'Refactoring-Tests-Core' with: [ spec requires: 'Refactoring-Core' ];
			package: 'Refactoring-Spelling' with: [ spec requires: 'Refactoring-Core' ];
			package: 'Refactoring-Tests-Spelling' with: [ spec requires: 'Refactoring-Spelling' ].
	
		spec
			group: 'default' with: #('Core' );
			group: 'Core' with: #( 'AST-Core' 'Refactoring-Core' 'Refactoring-Spelling' );
			group: 'Tests' with: #( 'AST-Tests-Core' 'Refactoring-Tests-Core' 'Refactoring-Tests-Spelling' );
			group: 'Core Tests' with: #('Core' 'Tests' );
			
			yourself.
	].
	spec for: #squeak do: [
		spec repository: 'http://source.wiresong.ca/ob/'.
		spec 
			package: 'AST-Core';
			package: 'Refactoring-Core' with: [ spec requires: 'AST-Core' ];
			package: 'Refactoring-Spelling' with: [ spec requires: 'Refactoring-Core' ].

		spec
			group: 'default' with: #('Core' );
			group: 'Core' with: #( 'AST-Core' 'Refactoring-Core' 'Refactoring-Spelling' );
			group: 'Tests' with: #('Core');
			group: 'Core Tests' with: #('Core' 'Tests' );
			
			yourself.
	].
! !

!ConfigurationOfRefactoringBrowser methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 12/18/2009 16:21'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		self class ensureMetacello.
		"Construct Metacello project"
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self.
		project := constructor project.
		project loadType: #linear.
		project ]! !

!ConfigurationOfRefactoringBrowser methodsFor: 'versions' stamp: 'MarianoMartinezPeck 1/14/2010 23:36'!
version10: spec
	<version: '1.0' imports: #('1.0-baseline')>

	spec for: #common do: [
		spec blessing: #release.
		spec author: 'MarianoMartinezPeck'.
		spec description: 'First release 1.0 of this project '.
	].

	spec for: #pharo do: [	
		spec 
			package: 'AST-Core' with: 'AST-Core-lr.49';
			package: 'AST-Tests' with: 'AST-Tests-lr.5';
			package: 'Refactoring-Core' with: 'Refactoring-Core-lr.94';
			package: 'Refactoring-Tests' with: 'Refactoring-Tests-lr.30';
			package: 'Refactoring-Spelling' with: 'Refactoring-Spelling-lr.13'.

	].
	spec for: #squeak do: [	
		spec author: 'DaleHenrichs'.
		spec description: 'Squeak support based on Squeak3.10.2-Trunk-090912 and OmniBrowser-2.0.3.sar'.
		spec 
			package: 'AST-Core' with: 'AST-Gwenael_Casaccio.215';
			package: 'Refactoring-Core' with: 'Refactoring-Core-lr.57';
			package: 'Refactoring-Spelling' with: 'Refactoring-Spelling-lr.6'.

	].
			! !

!ConfigurationOfRefactoringBrowser methodsFor: 'versions' stamp: 'MarianoMartinezPeck 1/22/2010 10:09'!
version11: spec
	<version: '1.1' imports: #('1.1-baseline')>

	spec for: #common do: [
		spec blessing: #development.
		spec author: 'MarianoMartinezPeck'.
		spec description: '- Added fixes and tests for Refactoring-Spelling
		- new versions '.
	].

	spec for: #pharo do: [	
		spec 
			package: 'AST-Core' with: 'AST-Core-lr.49';
			package: 'AST-Tests' with: 'AST-Tests-lr.5';
			package: 'Refactoring-Core' with: 'Refactoring-Core-lr.101';
			package: 'Refactoring-Tests' with: 'Refactoring-Tests-lr.31';
			package: 'Refactoring-Spelling' with: 'Refactoring-Spelling-lr.18'.
			"package: 'Refactoring-Tests-Spelling' with: 'Refactoring-Tests-Spelling-StanShepherd.11';
			package: 'Refactoring-Spelling-BugFixes' with: 'Refactoring-Spelling-BugFixes-StanShepherd.11'"

	].
	spec for: #squeak do: [	
		spec author: 'DaleHenrichs'.
		spec description: 'Squeak support based on Squeak3.10.2-Trunk-090912 and OmniBrowser-2.0.3.sar'.
		spec 
			package: 'AST-Core' with: 'AST-Gwenael_Casaccio.215';
			package: 'Refactoring-Core' with: 'Refactoring-Core-lr.57';
			package: 'Refactoring-Spelling' with: 'Refactoring-Spelling-lr.6'.

	].
			! !

!ConfigurationOfRefactoringBrowser methodsFor: 'versions' stamp: 'MarianoMartinezPeck 2/14/2010 20:16'!
version12: spec
	<version: '1.2' imports: #('1.2-baseline')>

	spec for: #common do: [
		spec blessing: #development.
		spec author: 'MarianoMartinezPeck'.
		spec description: '- Integrated the tests of Stan into the package:
Refactoring-Tests-Spelling.
-rename the tests packages of the rest of the refactoring browser to avoid conflicts. The packages are now called:
AST-Tests-Core and Refactoring-Tests-Core.
 '.
	].

	spec for: #pharo do: [	
		spec 
			package: 'AST-Core' with: 'AST-Core-lr.54';
			package: 'AST-Tests-Core' with: 'AST-Tests-Core-lr.6';
			package: 'Refactoring-Core' with: 'Refactoring-Core-lr.106';
			package: 'Refactoring-Tests-Core' with: 'Refactoring-Tests-Core-lr.32';
			package: 'Refactoring-Spelling' with: 'Refactoring-Spelling-lr.19';
			package: 'Refactoring-Tests-Spelling' with: 'Refactoring-Tests-Spelling-lr.3'.
			
	].
	spec for: #squeak do: [	
		spec author: 'DaleHenrichs'.
		spec description: 'Squeak support based on Squeak3.10.2-Trunk-090912 and OmniBrowser-2.0.3.sar'.
		spec 
			package: 'AST-Core' with: 'AST-Gwenael_Casaccio.215';
			package: 'Refactoring-Core' with: 'Refactoring-Core-lr.57';
			package: 'Refactoring-Spelling' with: 'Refactoring-Spelling-lr.6'.

	].
			! !
